"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTranslation = void 0;
var react_1 = require("react");
var mustache_1 = __importDefault(require("mustache"));
var DocViewerProvider_1 = require("../store/DocViewerProvider");
var i18n_1 = require("../utils/i18n");
var useTranslation = function () {
    var language = (0, react_1.useContext)(DocViewerProvider_1.DocViewerContext).state.language;
    var defaultTranslations = i18n_1.locales[i18n_1.defaultLanguage];
    var t = (0, react_1.useCallback)(function (key, variables) {
        var translations = i18n_1.locales[language];
        if (translations[key]) {
            return mustache_1.default.render(translations[key], variables);
        }
        if (defaultTranslations[key]) {
            return mustache_1.default.render(defaultTranslations[key], variables);
        }
        return key;
    }, [language, defaultTranslations]);
    return {
        t: t,
    };
};
exports.useTranslation = useTranslation;
