"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useWindowSize = void 0;
var react_1 = require("react");
var useWindowSize = function () {
    var _a = (0, react_1.useState)({
        width: undefined,
        height: undefined,
    }), windowSize = _a[0], setWindowSize = _a[1];
    (0, react_1.useEffect)(function () {
        function handleResize() {
            if (typeof window !== "undefined") {
                setWindowSize({
                    width: window.innerWidth,
                    height: window.innerHeight,
                });
            }
        }
        if (typeof window !== "undefined") {
            window.addEventListener("resize", handleResize);
            handleResize();
            return function () { return window.removeEventListener("resize", handleResize); };
        }
    }, []);
    return windowSize;
};
exports.useWindowSize = useWindowSize;
