"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
function parseCsvToRowsAndColumn(csvText, csvColumnDelimiter) {
    if (csvColumnDelimiter === void 0) { csvColumnDelimiter = "\t"; }
    var rows = csvText.split("\n");
    if (!rows || rows.length === 0) {
        return [];
    }
    return rows.map(function (row) { return row.split(csvColumnDelimiter); });
}
var CsvToHtmlTable = function (_a) {
    var data = _a.data, csvDelimiter = _a.csvDelimiter, hasHeader = _a.hasHeader, tableClassName = _a.tableClassName, tableRowClassName = _a.tableRowClassName, tableColumnClassName = _a.tableColumnClassName, rowKey = _a.rowKey, colKey = _a.colKey, renderCell = _a.renderCell;
    var rowsWithColumns = parseCsvToRowsAndColumn(data.trim(), csvDelimiter);
    var headerRow = undefined;
    if (hasHeader) {
        headerRow = rowsWithColumns.splice(0, 1)[0];
    }
    var renderTableHeader = function (row) {
        if (row && row.map) {
            return (react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null, row.map(function (column, i) { return (react_1.default.createElement("th", { key: "header-".concat(i) }, column)); }))));
        }
    };
    var renderTableBody = function (rows) {
        if (rows && rows.map) {
            return (react_1.default.createElement("tbody", null, rows.map(function (row, rowIdx) { return (react_1.default.createElement("tr", { className: tableRowClassName, key: typeof rowKey === "function" ? rowKey(row, rowIdx) : rowIdx }, row.map &&
                row.map(function (column, colIdx) { return (react_1.default.createElement("td", { className: tableColumnClassName, key: typeof rowKey === "function"
                        ? colKey(row, colIdx, rowIdx)
                        : column[colKey] }, typeof renderCell === "function"
                    ? renderCell(column, colIdx, rowIdx)
                    : column)); }))); })));
        }
    };
    return (react_1.default.createElement("table", { className: "csv-html-table ".concat(tableClassName) },
        renderTableHeader(headerRow),
        renderTableBody(rowsWithColumns)));
};
CsvToHtmlTable.defaultProps = {
    data: "",
    rowKey: function (row, rowIdx) { return "row-".concat(rowIdx); },
    colKey: function (col, colIdx) { return "col-".concat(colIdx); },
    hasHeader: true,
    csvDelimiter: "\t",
    tableClassName: "",
    tableRowClassName: "",
    tableColumnClassName: "",
};
exports.default = CsvToHtmlTable;
