"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocViewerProvider = exports.DocViewerContext = void 0;
var react_1 = __importStar(require("react"));
var i18n_1 = require("../utils/i18n");
var actions_1 = require("./actions");
var mainStateReducer_1 = require("./mainStateReducer");
var DocViewerContext = (0, react_1.createContext)({ state: mainStateReducer_1.initialState, dispatch: function () { return null; } });
exports.DocViewerContext = DocViewerContext;
var DocViewerProvider = function (props) {
    var _a;
    var children = props.children, documents = props.documents, config = props.config, pluginRenderers = props.pluginRenderers, prefetchMethod = props.prefetchMethod, requestHeaders = props.requestHeaders, initialActiveDocument = props.initialActiveDocument, language = props.language;
    var _b = (0, react_1.useReducer)(mainStateReducer_1.mainStateReducer, __assign(__assign({}, mainStateReducer_1.initialState), { documents: documents || [], currentDocument: documents && documents.length
            ? initialActiveDocument
                ? initialActiveDocument
                : documents[0]
            : undefined, config: config, pluginRenderers: pluginRenderers, prefetchMethod: prefetchMethod, requestHeaders: requestHeaders, currentFileNo: initialActiveDocument
            ? (_a = documents.findIndex(function (doc) { return doc === initialActiveDocument; })) !== null && _a !== void 0 ? _a : 0
            : 0, language: language && i18n_1.locales[language] ? language : i18n_1.defaultLanguage })), state = _b[0], dispatch = _b[1];
    (0, react_1.useEffect)(function () {
        dispatch((0, actions_1.setAllDocuments)(documents, initialActiveDocument));
        config && dispatch((0, actions_1.setMainConfig)(config));
    }, [documents, config, initialActiveDocument]);
    return (react_1.default.createElement(DocViewerContext.Provider, { value: { state: state, dispatch: dispatch } }, children));
};
exports.DocViewerProvider = DocViewerProvider;
