import React, { CSSProperties } from "react";
import { DocRenderer, IConfig, IDocument, ITheme } from "./models";
import { AvailableLanguages } from "./utils/i18n";
export interface DocViewerProps {
    documents: IDocument[];
    className?: string;
    style?: CSSProperties;
    config?: IConfig;
    theme?: ITheme;
    pluginRenderers?: DocRenderer[];
    prefetchMethod?: string;
    requestHeaders?: Record<string, string>;
    initialActiveDocument?: IDocument;
    language?: AvailableLanguages;
}
declare const _default: React.NamedExoticComponent<DocViewerProps>;
export default _default;
export { DocViewerRenderers } from "./plugins";
export * from "./models";
export * from "./utils/fileLoaders";
export { type AvailableLanguages } from "./utils/i18n";
export * from "./plugins";
