import { DocRenderer, IConfig, IDocument } from "..";
import { MainStateActions } from "./actions";
import { AvailableLanguages } from "../utils/i18n";
export declare type IMainState = {
    currentFileNo: number;
    documents: IDocument[];
    documentLoading?: boolean;
    currentDocument?: IDocument;
    rendererRect?: DOMRect;
    config?: IConfig;
    pluginRenderers?: DocRenderer[];
    prefetchMethod?: string;
    requestHeaders?: Record<string, string>;
    language: AvailableLanguages;
};
export declare const initialState: IMainState;
export declare type MainStateReducer = (state: IMainState, action: MainStateActions) => IMainState;
export declare const mainStateReducer: MainStateReducer;
